<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-51"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FGeneral%2FAudioPlayer%2FKKLAudioPlayer.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/General/AudioPlayer/KKLAudioPlayer.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3d53dd88e59abdcd55a12c7e475393fb.html">General</a></li><li class="navelem"><a class="el" href="dir_d3b5e5c108d43afe8610500a6d742d86.html">AudioPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">KKLAudioPlayer.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_k_k_l_audio_player_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  KKLAudioPlayer.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by 江俊辰 on 2017/9/27.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_k_k_l_audio_player_8h.html">KKLAudioPlayer.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="preprocessor">#import &lt;MediaPlayer/MediaPlayer.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="preprocessor">#import &lt;KKLThirdParty/ReactiveObjC.h&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html">   13</a></span>&nbsp;<span class="keyword">@interface </span><a class="code" href="interface_k_k_l_audio_player.html">KKLAudioPlayer</a>()</div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html#a6284778beef2a2d389581d89a17269d6">   14</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, strong, readonly) AVPlayer *player;</div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html#a11e5527dddcb1ffe9357b4651f4ab948">   15</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, strong, readwrite) id&lt;KKLAudioModel&gt; <a class="code" href="interface_k_k_l_audio_player.html#a5de997ab0e6131b1af5b6e1876146eaa">audio</a>;</div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html#aed8543adac80ee36a57fbe1645649ac8">   16</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, strong, readwrite) NSError *<a class="code" href="interface_k_k_l_audio_player.html#aa2b5e6476469b1ae714b94fd7646d369">error</a>;</div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html#abdb86592b755d2b78812c2fe6456c9b7">   17</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, assign, readwrite) KKLAudioPlayerStatus <a class="code" href="interface_k_k_l_audio_player.html#a93c9cceea19c110cc944eb278aceaee2">status</a>;</div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html#a93c0d8531da70db01d6dd9b8d8a0fc0f">   18</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, assign, readwrite) CMTime <a class="code" href="interface_k_k_l_audio_player.html#a032b079080271b43492dbefa93eb8147">currentTime</a>;</div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="category_k_k_l_audio_player_07_08.html#a2537ecac83a795290e033aac84057c12">   19</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, strong) <span class="keywordtype">id</span> timeObserver;</div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="interface_k_k_l_audio_player.html#a3a98a1dadd21b13b84ab7a8c65700cca">   20</a></span>&nbsp;<span class="keyword">@property</span> (nonatomic, assign) BOOL isSeeking;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;<span class="keyword">@end</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="interface_k_k_l_audio_player.html">KKLAudioPlayer</a></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;<span class="keyword">@synthesize</span> player = _player;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;@dynamic <a class="code" href="interface_k_k_l_audio_player.html#a38c6dc27351f467d3a8fac39618b991f">volume</a>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;<span class="preprocessor">#pragma mark - Public</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;- (void)setVolume:(CGFloat)volume {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;    <span class="keyword">self</span>.player.volume = <a class="code" href="interface_k_k_l_audio_player.html#a38c6dc27351f467d3a8fac39618b991f">volume</a>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;}</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;- (CGFloat)<a class="code" href="interface_k_k_l_audio_player.html#a38c6dc27351f467d3a8fac39618b991f">volume</a> {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;    <span class="keywordflow">return</span> <span class="keyword">self</span>.player.volume;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;}</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;- (void)replayAudio:(<span class="keywordtype">id</span>&lt;<a class="code" href="protocol_k_k_l_audio_model-p.html">KKLAudioModel</a>&gt;)audio {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    [<span class="keyword">self</span> replayAudio:audio withStartTime:kCMTimeZero];</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;- (void)replayAudio:(<span class="keywordtype">id</span>&lt;<a class="code" href="protocol_k_k_l_audio_model-p.html">KKLAudioModel</a>&gt;)audio withStartTime:(CMTime)currentTime {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;    <span class="keywordflow">if</span> (_player) {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;        [<span class="keyword">self</span> pause];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;        [<span class="keyword">self</span> removeObserverForPlayer:_player];</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;    }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;    _audio = <a class="code" href="interface_k_k_l_audio_player.html#a5de997ab0e6131b1af5b6e1876146eaa">audio</a>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;    _error = nil;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;    <span class="keywordflow">if</span> (<a class="code" href="interface_k_k_l_audio_player.html#a5de997ab0e6131b1af5b6e1876146eaa">audio</a> &amp;&amp; [<a class="code" href="interface_k_k_l_audio_player.html#a5de997ab0e6131b1af5b6e1876146eaa">audio</a> respondsToSelector:<span class="keyword">@selector</span>(audioTotalTime)]) {</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;        _totalTime = [audio <a class="code" href="protocol_k_k_l_audio_model-p.html#ac18e42d0433d4257ab5c9b27db715853">audioTotalTime</a>];</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    }</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;    <span class="keyword">self</span>.currentTime = <a class="code" href="interface_k_k_l_audio_player.html#a032b079080271b43492dbefa93eb8147">currentTime</a>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusLoading;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;    </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;    AVPlayerItem *item = [AVPlayerItem playerItemWithURL:[_audio audioURL]];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;    [<span class="keyword">self</span>.player replaceCurrentItemWithPlayerItem:item];</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;    [<span class="keyword">self</span> addObserverForPlayer:_player];</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;    </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;    <span class="comment">// 开始接受远程控制</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;    [[UIApplication sharedApplication] beginReceivingRemoteControlEvents];</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;    [<span class="keyword">self</span> play];</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;}</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;- (void)<a class="code" href="interface_k_k_l_audio_player.html#ac64ebf0b646d70c086efbef451da5ea8">play</a> {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;    _error = nil;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusLoading;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;    <span class="comment">// 告诉app支持后台播放</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp;    AVAudioSession *audioSession = [AVAudioSession sharedInstance];</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;    [audioSession setCategory:AVAudioSessionCategoryPlayback withOptions:AVAudioSessionCategoryOptionMixWithOthers error:nil];</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp;    [audioSession setActive:YES error:nil];</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;    </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp;    <span class="keywordflow">if</span> (!<span class="keyword">self</span>.timeObserver) {</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp;        @weakify(<span class="keyword">self</span>);</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp;        <span class="keyword">self</span>.timeObserver = [<span class="keyword">self</span>.player addPeriodicTimeObserverForInterval:CMTimeMake(1, 1) queue:NULL usingBlock:^(CMTime time) {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;            @strongify(self);</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;            if (!self.isSeeking) {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;                <span class="keyword">self</span>.currentTime = time;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp;            }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp;        }];</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;    }</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp;    </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;    dispatch_async(dispatch_get_main_queue(), ^{</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp;        <span class="keywordflow">if</span> (CMTimeCompare(<span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a032b079080271b43492dbefa93eb8147">currentTime</a>, <span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a530cc524d9a02634421aaad0d565e0ed">totalTime</a>) &gt;= 0) {</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&nbsp;            <span class="keyword">self</span>.currentTime = kCMTimeZero;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&nbsp;            [<span class="keyword">self</span>.player seekToTime:self.currentTime];</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp;        }</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&nbsp;        [<span class="keyword">self</span>.player play];</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&nbsp;        <span class="keywordflow">if</span> (<span class="keyword">self</span>.player.currentItem.status == AVPlayerItemStatusReadyToPlay) {</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&nbsp;            self.status = KKLAudioPlayerStatusPlaying;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&nbsp;        }</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&nbsp;        [<span class="keyword">self</span> updateLockView];</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&nbsp;    });</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&nbsp;}</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&nbsp; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&nbsp;- (void)<a class="code" href="interface_k_k_l_audio_player.html#ab8f66c583ae6f4c3865fc3a3f7e63562">pause</a> {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&nbsp;    [_player pause];</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>.timeObserver) {</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&nbsp;        [_player removeTimeObserver:self.timeObserver];</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&nbsp;        <span class="keyword">self</span>.timeObserver = nil;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&nbsp;    }</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusPaused;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&nbsp;}</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&nbsp; </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&nbsp;- (void)<a class="code" href="interface_k_k_l_audio_player.html#a54e74db0c308b1b8e03200c77bd4db64">reset</a> {</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&nbsp;    [<span class="keyword">self</span> pause];</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&nbsp;    <span class="comment">// 关闭远程控制</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&nbsp;    [[UIApplication sharedApplication] endReceivingRemoteControlEvents];</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&nbsp;    [<span class="keyword">self</span> removeObserverForPlayer:_player];</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusUnknow;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&nbsp;    <span class="keyword">self</span>.error = nil;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&nbsp;    <span class="keyword">self</span>.currentTime = kCMTimeZero;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&nbsp;    _totalTime = kCMTimeZero;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&nbsp;    _player = nil;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&nbsp;    _audio = nil;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&nbsp;}</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&nbsp; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&nbsp;- (void)seekToTime:(CMTime)time {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&nbsp;    <span class="keywordflow">if</span> (CMTimeCompare(time, <span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a530cc524d9a02634421aaad0d565e0ed">totalTime</a>) == 0) {</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&nbsp;        NSTimeInterval seconds = CMTimeGetSeconds(time);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&nbsp;        seconds = MAX(0, (seconds - 1));</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&nbsp;        time = CMTimeMake(seconds * time.timescale, time.timescale);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&nbsp;    }</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&nbsp;    <span class="keyword">self</span>.isSeeking = YES;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&nbsp;    <span class="keyword">self</span>.currentTime = time;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusLoading;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&nbsp;    @weakify(<span class="keyword">self</span>);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&nbsp;    [_player seekToTime:time completionHandler:^(BOOL finished) {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&nbsp;        @strongify(self);</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&nbsp;        self.isSeeking = NO;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&nbsp;        [<span class="keyword">self</span> updateLockView];</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&nbsp;        self.status = KKLAudioPlayerStatusPlaying;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&nbsp;    }];</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&nbsp;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&nbsp; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&nbsp;<span class="preprocessor">#pragma mark - Getter</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&nbsp;- (AVPlayer *)player {</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&nbsp;    <span class="keywordflow">if</span> (!_player) {</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&nbsp;        _player = [AVPlayer playerWithPlayerItem:nil];</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&nbsp;    }</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&nbsp;    <span class="keywordflow">return</span> _player;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&nbsp;}</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&nbsp; </div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&nbsp;<span class="preprocessor">#pragma mark - 更新后台播放UI</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&nbsp;- (void)updateLockView {</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&nbsp;    <span class="keywordflow">if</span> (!<span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a6b1cfeef11def971bf6e34059ea4a4ca">shouldUpdatePlayerWidget</a>) {</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&nbsp;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&nbsp;    }</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&nbsp;    NSMutableDictionary *musicInfo = [NSMutableDictionary dictionary];</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&nbsp;    <span class="comment">// 设置Singer</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&nbsp;    [musicInfo setValue:[<span class="keyword">self</span>.audio audioArtist] forKey:MPMediaItemPropertyArtist];</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&nbsp;    <span class="comment">// 设置歌曲名</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&nbsp;    [musicInfo setValue:[<span class="keyword">self</span>.audio audioTitle] forKey:MPMediaItemPropertyTitle];</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&nbsp;    <span class="comment">// 音乐当前时间</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&nbsp;    [musicInfo setObject:@(CMTimeGetSeconds(self.currentTime)) forKey:MPNowPlayingInfoPropertyElapsedPlaybackTime];</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&nbsp;    <span class="comment">// 歌曲总时间</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&nbsp;    [musicInfo setObject:@(CMTimeGetSeconds(self.totalTime)) forKey:MPMediaItemPropertyPlaybackDuration];</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&nbsp;    [[MPNowPlayingInfoCenter defaultCenter] setNowPlayingInfo:musicInfo];</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&nbsp;}</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&nbsp; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&nbsp;<span class="preprocessor">#pragma mark - Observer</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&nbsp;- (void)removeObserverForPlayer:(AVPlayer *)player {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&nbsp;    <span class="keywordflow">@try</span> {</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&nbsp;        [player.currentItem removeObserver:self forKeyPath:@&#34;status&#34;];</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&nbsp;    }</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&nbsp;    <span class="keywordflow">@catch</span> (NSException *exception) {</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&nbsp;        <span class="comment">// observer doesn&#39;t exist, do nothing</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&nbsp;    }</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&nbsp;}</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&nbsp; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&nbsp;- (void)addObserverForPlayer:(AVPlayer *)player {</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&nbsp;    [player.currentItem addObserver:self forKeyPath:@&#34;status&#34; options:NSKeyValueObservingOptionNew context:nil];</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&nbsp;    </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&nbsp;    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(playerDidEnd:)</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&nbsp;                                                 name:AVPlayerItemDidPlayToEndTimeNotification object:_player.currentItem];</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&nbsp;    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(playbackStalled:)</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&nbsp;                                                 name:AVPlayerItemPlaybackStalledNotification object:_player.currentItem];</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&nbsp;}</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&nbsp; </div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&nbsp;- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(<span class="keywordtype">id</span>)object</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&nbsp;                        change:(NSDictionary&lt;NSKeyValueChangeKey,<span class="keywordtype">id</span>&gt; *)change context:(<span class="keywordtype">void</span> *)context {</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&nbsp;    <span class="keywordflow">if</span> ([keyPath isEqualToString:<span class="stringliteral">@&#34;status&#34;</span>]) {</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&nbsp;        </div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&nbsp;        AVPlayerItem *playerItem =(AVPlayerItem *)<span class="keywordtype">object</span>;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&nbsp;        </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&nbsp;        <span class="keywordflow">if</span> (playerItem.status == AVPlayerItemStatusReadyToPlay) {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&nbsp;            <span class="comment">// 正确播放</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&nbsp;            <span class="keywordflow">if</span> (CMTimeCompare(<span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a530cc524d9a02634421aaad0d565e0ed">totalTime</a>, playerItem.duration) != 0) {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&nbsp;                _totalTime = playerItem.duration;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&nbsp;                [<span class="keyword">self</span> updateLockView];</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&nbsp;            }</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a93c9cceea19c110cc944eb278aceaee2">status</a> == KKLAudioPlayerStatusLoading) {</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&nbsp;                <span class="keyword">self</span>.status = KKLAudioPlayerStatusPlaying;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&nbsp;            }</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&nbsp;        } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (playerItem.status == AVPlayerItemStatusFailed) {</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&nbsp;            <span class="comment">// 播放失败</span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&nbsp;            <span class="keywordflow">if</span> (<span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a93c9cceea19c110cc944eb278aceaee2">status</a> == KKLAudioPlayerStatusLoading || <span class="keyword">self</span>.<a class="code" href="interface_k_k_l_audio_player.html#a93c9cceea19c110cc944eb278aceaee2">status</a> == KKLAudioPlayerStatusPlaying) {</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&nbsp;                <span class="keyword">self</span>.error = [NSError errorWithDomain:@&#34;播放错误&#34; code:-1 userInfo:nil];</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&nbsp;            }</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&nbsp;            <span class="keyword">self</span>.status = KKLAudioPlayerStatusPaused;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&nbsp;        }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&nbsp;    }</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&nbsp;}</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&nbsp; </div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&nbsp;- (void)playerDidEnd:(NSNotification *)notify {</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusEnd;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&nbsp;}</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&nbsp; </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&nbsp;- (void)playbackStalled:(NSNotification *)notify {</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&nbsp;    <span class="keyword">self</span>.status = KKLAudioPlayerStatusLoading;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&nbsp;}</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&nbsp;- (void)dealloc {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&nbsp;    NSLog(<span class="stringliteral">@&#34;audio dealloc&#34;</span>);</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&nbsp;}</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a5de997ab0e6131b1af5b6e1876146eaa"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a5de997ab0e6131b1af5b6e1876146eaa">KKLAudioPlayer::audio</a></div><div class="ttdeci">id&lt; KKLAudioModel &gt; audio</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00033">KKLAudioPlayer.h:33</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_ac64ebf0b646d70c086efbef451da5ea8"><div class="ttname"><a href="interface_k_k_l_audio_player.html#ac64ebf0b646d70c086efbef451da5ea8">-[KKLAudioPlayer play]</a></div><div class="ttdeci">void play()</div><div class="ttdoc">从当前进度开始播放</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8m_source.html#l00020">KKLAudioPlayer.m:63</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a54e74db0c308b1b8e03200c77bd4db64"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a54e74db0c308b1b8e03200c77bd4db64">-[KKLAudioPlayer reset]</a></div><div class="ttdeci">void reset()</div><div class="ttdoc">重置播放器</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8m_source.html#l00020">KKLAudioPlayer.m:105</a></div></div>
<div class="ttc" id="aprotocol_k_k_l_audio_model-p_html"><div class="ttname"><a href="protocol_k_k_l_audio_model-p.html">KKLAudioModel-p</a></div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00020">KKLAudioPlayer.h:20</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a38c6dc27351f467d3a8fac39618b991f"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a38c6dc27351f467d3a8fac39618b991f">KKLAudioPlayer::volume</a></div><div class="ttdeci">CGFloat volume</div><div class="ttdoc">音量</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00045">KKLAudioPlayer.h:45</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a530cc524d9a02634421aaad0d565e0ed"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a530cc524d9a02634421aaad0d565e0ed">KKLAudioPlayer::totalTime</a></div><div class="ttdeci">CMTime totalTime</div><div class="ttdoc">总共播放时间</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00039">KKLAudioPlayer.h:39</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_ab8f66c583ae6f4c3865fc3a3f7e63562"><div class="ttname"><a href="interface_k_k_l_audio_player.html#ab8f66c583ae6f4c3865fc3a3f7e63562">-[KKLAudioPlayer pause]</a></div><div class="ttdeci">void pause()</div><div class="ttdoc">暂停播放</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8m_source.html#l00020">KKLAudioPlayer.m:95</a></div></div>
<div class="ttc" id="a_k_k_l_audio_player_8h_html"><div class="ttname"><a href="_k_k_l_audio_player_8h.html">KKLAudioPlayer.h</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html"><div class="ttname"><a href="interface_k_k_l_audio_player.html">KKLAudioPlayer</a></div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00032">KKLAudioPlayer.h:33</a></div></div>
<div class="ttc" id="aprotocol_k_k_l_audio_model-p_html_ac18e42d0433d4257ab5c9b27db715853"><div class="ttname"><a href="protocol_k_k_l_audio_model-p.html#ac18e42d0433d4257ab5c9b27db715853">-[KKLAudioModel-p audioTotalTime]</a></div><div class="ttdeci">CMTime audioTotalTime()</div><div class="ttdoc">总时长</div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_aa2b5e6476469b1ae714b94fd7646d369"><div class="ttname"><a href="interface_k_k_l_audio_player.html#aa2b5e6476469b1ae714b94fd7646d369">KKLAudioPlayer::error</a></div><div class="ttdeci">NSError * error</div><div class="ttdoc">播放错误(可用于KVO)</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00041">KKLAudioPlayer.h:41</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a6b1cfeef11def971bf6e34059ea4a4ca"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a6b1cfeef11def971bf6e34059ea4a4ca">KKLAudioPlayer::shouldUpdatePlayerWidget</a></div><div class="ttdeci">BOOL shouldUpdatePlayerWidget</div><div class="ttdoc">是否需要更新后台播放器插件</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00043">KKLAudioPlayer.h:43</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a032b079080271b43492dbefa93eb8147"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a032b079080271b43492dbefa93eb8147">KKLAudioPlayer::currentTime</a></div><div class="ttdeci">CMTime currentTime</div><div class="ttdoc">当前的播放时间(可用于KVO)</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00037">KKLAudioPlayer.h:37</a></div></div>
<div class="ttc" id="ainterface_k_k_l_audio_player_html_a93c9cceea19c110cc944eb278aceaee2"><div class="ttname"><a href="interface_k_k_l_audio_player.html#a93c9cceea19c110cc944eb278aceaee2">KKLAudioPlayer::status</a></div><div class="ttdeci">KKLAudioPlayerStatus status</div><div class="ttdoc">播放状态(可用于KVO)</div><div class="ttdef"><b>Definition:</b> <a href="_k_k_l_audio_player_8h_source.html#l00035">KKLAudioPlayer.h:35</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>